#!/usr/bin/perl
# fixup-writegroupincludes.pl
#                   RBLandau 20070918
#
# Produce one or two interleaved lists of #include statements in group order. 

use English; 
use newtrace;

my $sPrefix = "pdm";

if ( !defined($ARGV[2-1]) )
{
    print "Usage: skel-writegroupincludes  grouporder-file  {type|type1 type2}\n";
    print "       where type = enums|tables|props\n";
    exit; 
}

# Get group numbers
newtrace::trace( 1,"file1=|$ARGV[1-1]|");
open( GROUPS, "<", $ARGV[1-1] ) || die "Error: cannot open grouporder file $ARGV[1-1]";

$sGroupType = $ARGV[2-1];
if (defined ($ARGV[3-1])) { $sSecondGroupType = $ARGV[3-1] };

# Absorb the grouporder list into a hash.
while (<GROUPS>)
{
    $sLine = $_;
    $sGroupName = "";
    next if /^\s*$/;
    next if /^\s*#/;
    ($sGroupName,$sGroupNumber) = $sLine =~ /^(\S+)\s+(\d+)\s*$/;
    if ($sGroupName)
    {
        $sFullName = $sGroupName;
        $sFullNumber = sprintf("%04d",$sGroupNumber);
        $hGroupNum2Name{$sFullNumber} = $sFullName;
    } else
    {
        die "Error: syntax error in line |$sLine|\n";
    }
    newtrace::trace(1,"proc  fullname|$sFullName|=|$sFullNumber|");
}

for $nGroupNumber (sort keys %hGroupNum2Name)
{
    print "#include mib/$hGroupNum2Name{$nGroupNumber}.$sGroupType.mib\n";
    if (defined($sSecondGroupType))
    {
        print "#include mib/$hGroupNum2Name{$nGroupNumber}.$sSecondGroupType.mib\n";
    }
}

